/*

Copyright Yann OLLIVIER 1997-1999

This software may be freely distributed as is, including
this whole notice.

It may be modified, but any modification should include this whole notice as 
is and a description of the changes made.

This software may not be sold.

This software or any modified version of it may be freely used in free
programs. The program should include a copy of this whole notice. If you
want to use it in a program you sell, contact me

This software comes with absolutely no warranty.

*/

#include <stdio.h>
#include <gtk/gtk.h>
#include "eqdiff.h"

void Fenetre::Retaille(long int xs,long int ys)
{
  xpc=xs/2;ypc=ys/2;
  xr=xpc;yr=ypc;
  if(EchUnif==1)yr=xr*xyR;
  else if(EchUnif==2)xr=yr/xyR;
  if(hdcMem)Retrace();
}

gint configure_event(GtkWidget *widget, GdkEventConfigure*,gpointer data)
{
  Fenetre*fen=(Fenetre*)data;
  if(fen->hbmMem!=NULL)gdk_pixmap_unref(fen->hbmMem);
  fen->hbmMem = gdk_pixmap_new(widget->window,
			  widget->allocation.width,
			  widget->allocation.height,
			  -1);
  fen->Retaille(widget->allocation.width,widget->allocation.height);
  return TRUE;
}

gint expose_event(GtkWidget *widget, GdkEventExpose *event,gpointer data)
{
  Fenetre*fen=(Fenetre*)data;
  fen->Paint(widget,event);
  return FALSE;
}

void quit ()
{gtk_exit (0);}

gint motion_notify_event (GtkWidget*, GdkEventMotion *event,gpointer data)
{
  Fenetre*fen=(Fenetre*)data;
  fen->MouseMove((int)event->x,(int)event->y);
  return TRUE;
}

gint no_delete_event(GtkWidget*,GdkEvent*,gpointer){return TRUE;}

void redraw_event(GtkWidget*,gpointer data)
{((Fenetre*)data)->Redraw();}
void trace_event(GtkWidget*,gpointer data)
{((Fenetre*)data)->Trace();}
void axesdialog_event(GtkWidget*,gpointer data)
{((Fenetre*)data)->AxesDialog();}
void axesdialogok_event(GtkWidget*,gpointer data)
{((Fenetre*)data)->AxesDialogOK();}
void axesdialogcancel_event(GtkWidget*,gpointer data)
{((Fenetre*)data)->AxesDialogCancel();}
void axescolorseldialog_event(GtkWidget*,gpointer data)
{((Fenetre*)data)->AxesColorSelDialog();}
void axescolorseldialogok_event(GtkWidget*,gpointer data)
{((Fenetre*)data)->AxesColorSelDialogOK();}
void axescolorseldialogcancel_event(GtkWidget*,gpointer data)
{((Fenetre*)data)->AxesColorSelDialogCancel();}
void wcolorseldialog_event(GtkWidget*,gpointer data)
{((Fenetre*)data)->WColorSelDialog();}
void wcolorseldialogok_event(GtkWidget*,gpointer data)
{((Fenetre*)data)->WColorSelDialogOK();}
void wcolorseldialogcancel_event(GtkWidget*,gpointer data)
{((Fenetre*)data)->WColorSelDialogCancel();}
void zoomdialog_event(GtkWidget*,gpointer data)
{((Fenetre*)data)->ZoomDialog();}
void zoomdialogok_event(GtkWidget*,gpointer data)
{((Fenetre*)data)->ZoomDialogOK();}
void zoomdialogcancel_event(GtkWidget*,gpointer data)
{((Fenetre*)data)->ZoomDialogCancel();}
void foncsell_event(GtkWidget*,gpointer data)
{((Fenetre*)data)->FoncSelLChanged();}
void family_event(GtkWidget*,gpointer data)
{((Fenetre*)data)->Family();}
void level_event(GtkWidget*,gpointer data)
{((Fenetre*)data)->Level();}
void cross_event(GtkWidget*,gpointer data)
{((Fenetre*)data)->Cross();}
void inflex_event(GtkWidget*,gpointer data)
{((Fenetre*)data)->Inflex();}
void limcurves_event(GtkWidget*,gpointer data)
{((Fenetre*)data)->LimCurves();}
void panorama_event(GtkWidget*,gpointer data)
{((Fenetre*)data)->Panorama();}
void save_event(GtkWidget*,gpointer data)
{((Fenetre*)data)->Save();}
void saveimagexpm_event(GtkWidget*,gpointer data)
{((Fenetre*)data)->SaveImageXPM();}
void saveimageppm_event(GtkWidget*,gpointer data)
{((Fenetre*)data)->SaveImagePPM();}
void load_event(GtkWidget*,gpointer data)
{((Fenetre*)data)->Load();}
void merge_event(GtkWidget*,gpointer data)
{((Fenetre*)data)->Merge();}
void crbdel_event(GtkWidget*,gpointer data)
{((Fenetre*)data)->CrbDel();}
void foncdel_event(GtkWidget*,gpointer data)
{((Fenetre*)data)->FoncDel();}
void optdialog_event(GtkWidget*,gpointer data)
{((Fenetre*)data)->OptDialog();}
void optdialogok_event(GtkWidget*,gpointer data)
{((Fenetre*)data)->OptDialogOK();}
void optdialogcancel_event(GtkWidget*,gpointer data)
{((Fenetre*)data)->OptDialogCancel();}
void funccolorseldialog_event(GtkWidget*,gpointer data)
{((Fenetre*)data)->FuncColorSelDialog();}
void funccolorseldialogok_event(GtkWidget*,gpointer data)
{((Fenetre*)data)->FuncColorSelDialogOK();}
void funccolorseldialogcancel_event(GtkWidget*,gpointer data)
{((Fenetre*)data)->FuncColorSelDialogCancel();}

gint button_press_event (GtkWidget *, GdkEventButton *event,gpointer data)
{
  Fenetre*fen=(Fenetre*)data;
  if(event->button==1){
    fen->Button1((int)event->x,(int)event->y);
  }
  if(event->button==2||event->button==3){
    if(fen->Wait){
      if(event->type==GDK_2BUTTON_PRESS)fen->Interrupt=3;else fen->Interrupt=1;
    }else{
      fen->CrbDel();
    }
  }
  return TRUE;
}

void coords_event(GtkWidget*,gint s,gint,GdkEvent*,gpointer data)
{((Fenetre*)data)->Coords(s);}
void nature_event(GtkWidget*widget,gpointer data)
{if(GTK_TOGGLE_BUTTON(widget)->active)((Fenetre*)data)->Nature();}
void expredch_event(GtkWidget*,gpointer data)
{((Fenetre*)data)->ExprEdCh=1;}
void dredch_event(GtkWidget*,gpointer data)
{((Fenetre*)data)->drEdCh=1;}
void minpedch_event(GtkWidget*,gpointer data)
{((Fenetre*)data)->minpEdCh=1;}
void maxpedch_event(GtkWidget*,gpointer data)
{((Fenetre*)data)->maxpEdCh=1;}
void funcok_event(GtkWidget*,gpointer data)
{((Fenetre*)data)->FuncOK();}
void flistselect_event(GtkWidget*,gint n,gint,GdkEvent*,gpointer data)
{((Fenetre*)data)->FListSelect(n);}
void flistunselect_event(GtkWidget*,gint,gint,GdkEvent*,gpointer data)
{((Fenetre*)data)->FListUnselect();}
void funcdestroy_event(GtkWidget*,gpointer data)
{((Fenetre*)data)->FuncDestroy();}
void funcnew_event(GtkWidget*,gpointer data)
{((Fenetre*)data)->FuncNew();}
void funcren_event(GtkWidget*,gpointer data)
{((Fenetre*)data)->FuncRen();}
void funcrecalc_event(GtkWidget*,gpointer data)
{((Fenetre*)data)->FuncRecalc();}

Fenetre::Fenetre()
{
  xech=4.;yech=4.;xlc=ylc=xaxe=yaxe=0;xgrad=ygrad=1;Interrupt=0;Wait=0;
  EchUnif=1;xyR=1;Suivre=0;esp=0.1;niv=0;dxsens=0;dysens=0;
  x=y=t=a=r=0;pxvar=new RVar("x",&x);pyvar=new RVar("y",&y);
  prvar=new RVar("r",&r);pavar=new RVar("a",&a);ptvar=new RVar("t",&t);
  xcurs=ErrVal;ycurs=ErrVal;
  LFonctions=*new TList<TFonction>;
  GdkColor color=RGB(65535,65535,65535);
  HPEN hp=CreatePen(PS_SOLID,1,color);
  LFonctions.AddObject(new TFonction("Default values",new ROperation,0.01,hp,0
				     ,0,1,ErrVal,ErrVal));
  PFoncSel=&LFonctions[0];
  char*s=new char[1];s[0]=0;FoncSelList=g_list_append(NULL,s);
  axep=CreatePen(PS_SOLID,1,RGB(65535,39322,26214));
  Contexte=0;
  PSelCourbeFonc=NULL;SelCourbe=-1;
  FBornes=0;
  LCourbesLim=*new TList<TCourbe>;

  window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_name (window, "Diffs");
  gtk_window_set_title(GTK_WINDOW(window),"Diffs");
  gtk_signal_connect (GTK_OBJECT (window), "destroy",
      GTK_SIGNAL_FUNC (quit), NULL);
  gtk_window_set_policy (GTK_WINDOW(window),TRUE,TRUE,TRUE);

  hbmMem=NULL;hdcMem=NULL;
  drawing_area=gtk_drawing_area_new();
  gtk_container_add (GTK_CONTAINER (window), drawing_area);
  gtk_drawing_area_size(GTK_DRAWING_AREA(drawing_area),500,500);
  gtk_widget_show (drawing_area);
  gtk_signal_connect (GTK_OBJECT (drawing_area), "expose_event",
		      (GtkSignalFunc)expose_event,(gpointer)this);
  gtk_signal_connect (GTK_OBJECT(drawing_area),"configure_event",
		      (GtkSignalFunc)configure_event,(gpointer)this);
  gtk_signal_connect (GTK_OBJECT (drawing_area), "motion_notify_event",
                      (GtkSignalFunc) motion_notify_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(drawing_area),"button_press_event",
		     (GtkSignalFunc)button_press_event,(gpointer)this);
  gtk_widget_set_events (drawing_area,GDK_POINTER_MOTION_MASK|GDK_BUTTON_PRESS_MASK);
  gtk_widget_show (window);
  hdc=new DC(this);hdcMem=new DC(this);
  hdc->drawable=&drawing_area->window;
  hdcMem->drawable=&hbmMem;
  bgcolor=RGB(0,0,0);
  GdkColormap *colormap;
  colormap = gdk_window_get_colormap (drawing_area->window);
  gdk_color_alloc (colormap, &bgcolor);
  gdk_color_alloc(colormap,&axep->color);
  gdk_color_alloc(colormap,&color);

  SetupFuncDial();SetupActDial();SetupZoomDial();SetupAxesDial();SetupOptDial();
  Retrace();
  AxesColorSelDial=gtk_color_selection_dialog_new("Axes color");
  WColorSelDial=gtk_color_selection_dialog_new("Window background color");
  gtk_widget_hide(GTK_COLOR_SELECTION_DIALOG(AxesColorSelDial)->help_button);
  gtk_widget_hide(GTK_COLOR_SELECTION_DIALOG(WColorSelDial)->help_button);
  gtk_widget_hide(AxesColorSelDial);
  gtk_widget_hide(WColorSelDial);
  FuncColorSelDial=gtk_color_selection_dialog_new("Function color");
  gtk_widget_hide(GTK_COLOR_SELECTION_DIALOG(FuncColorSelDial)->help_button);
  gtk_widget_hide(FuncColorSelDial);
  gtk_widget_hide(AxesDial);
  gtk_widget_hide(ZoomDial);
  gtk_widget_hide(OptDial);
  gtk_widget_set_sensitive(PanoramaB,FALSE);
  gtk_widget_set_sensitive(LimCurvesB,FALSE);
  gtk_widget_set_sensitive(FamilyB,FALSE);
  gtk_widget_set_sensitive(LevelB,FALSE);
  gtk_widget_set_sensitive(CrossB,FALSE);
  gtk_widget_set_sensitive(InflexB,FALSE);
  gtk_widget_set_sensitive(CrbDelB,FALSE);
  gtk_widget_set_sensitive(FoncDelB,FALSE);
  gtk_widget_set_sensitive(OptB,FALSE);
  gtk_signal_connect(GTK_OBJECT(RedrawB),"clicked",(GtkSignalFunc)redraw_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(Redraw2B),"clicked",(GtkSignalFunc)redraw_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(TraceCB),"toggled",(GtkSignalFunc)trace_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(AxesB),"clicked",(GtkSignalFunc)axesdialog_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(AxesDialogOKB),"clicked",
		     (GtkSignalFunc)axesdialogok_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(xaxeEd),"activate",
		     (GtkSignalFunc)axesdialogok_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(yaxeEd),"activate",
		     (GtkSignalFunc)axesdialogok_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(xgradEd),"activate",
		     (GtkSignalFunc)axesdialogok_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(ygradEd),"activate",
		     (GtkSignalFunc)axesdialogok_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(AxesDialogCancelB),"clicked",
		     (GtkSignalFunc)axesdialogcancel_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(AxesDial),"delete_event",
      (GtkSignalFunc)no_delete_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(AxesColorB),"clicked",
		     (GtkSignalFunc)axescolorseldialog_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(GTK_COLOR_SELECTION_DIALOG(AxesColorSelDial)->ok_button),"clicked",
		     (GtkSignalFunc)axescolorseldialogok_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(GTK_COLOR_SELECTION_DIALOG(AxesColorSelDial)->cancel_button),"clicked",
		     (GtkSignalFunc)axescolorseldialogcancel_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(AxesColorSelDial),"delete_event",
		     (GtkSignalFunc)no_delete_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(WColorB),"clicked",
		     (GtkSignalFunc)wcolorseldialog_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(GTK_COLOR_SELECTION_DIALOG(WColorSelDial)->ok_button),"clicked",
		     (GtkSignalFunc)wcolorseldialogok_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(GTK_COLOR_SELECTION_DIALOG(WColorSelDial)->cancel_button),"clicked",
		     (GtkSignalFunc)wcolorseldialogcancel_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(WColorSelDial),"delete_event",
		     (GtkSignalFunc)no_delete_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(ZoomB),"clicked",(GtkSignalFunc)zoomdialog_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(ZoomDialogOKB),"clicked",
		     (GtkSignalFunc)zoomdialogok_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(xlcEd),"activate",
		     (GtkSignalFunc)zoomdialogok_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(ylcEd),"activate",
		     (GtkSignalFunc)zoomdialogok_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(xechEd),"activate",
		     (GtkSignalFunc)zoomdialogok_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(yechEd),"activate",
		     (GtkSignalFunc)zoomdialogok_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(xyEd),"activate",
		     (GtkSignalFunc)zoomdialogok_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(WAspEd),"activate",
		     (GtkSignalFunc)zoomdialogok_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(ZoomDialogCancelB),"clicked",
		     (GtkSignalFunc)zoomdialogcancel_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(ZoomDial),"delete_event",
		     (GtkSignalFunc)no_delete_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(GTK_COMBO(FoncSelL)->entry),"changed",
		     (GtkSignalFunc)foncsell_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(FamilyB),"clicked",
		     (GtkSignalFunc)family_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(LevelB),"clicked",
		     (GtkSignalFunc)level_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(CrossB),"clicked",
		     (GtkSignalFunc)cross_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(InflexB),"clicked",
		     (GtkSignalFunc)inflex_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(LimCurvesB),"clicked",
		     (GtkSignalFunc)limcurves_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(PanoramaB),"clicked",
		     (GtkSignalFunc)panorama_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(CrbDelB),"clicked",
		     (GtkSignalFunc)crbdel_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(FoncDelB),"clicked",
		     (GtkSignalFunc)foncdel_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(OptB),"clicked",(GtkSignalFunc)optdialog_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(OptDialogOKB),"clicked",
		     (GtkSignalFunc)optdialogok_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(OptDialogCancelB),"clicked",
		     (GtkSignalFunc)optdialogcancel_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(OptDial),"delete_event",
      (GtkSignalFunc)no_delete_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(FuncColorB),"clicked",
		     (GtkSignalFunc)funccolorseldialog_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(GTK_COLOR_SELECTION_DIALOG(FuncColorSelDial)->ok_button),"clicked",
		     (GtkSignalFunc)funccolorseldialogok_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(GTK_COLOR_SELECTION_DIALOG(FuncColorSelDial)->cancel_button),"clicked",
		     (GtkSignalFunc)funccolorseldialogcancel_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(FuncColorSelDial),"delete_event",
		     (GtkSignalFunc)no_delete_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(TypeList),"select_row",
		     (GtkSignalFunc)coords_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(FoncRB),"toggled",
		     (GtkSignalFunc)nature_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(DiffRB),"toggled",
		     (GtkSignalFunc)nature_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(NivRB),"toggled",
		     (GtkSignalFunc)nature_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(ChampRB),"toggled",
		     (GtkSignalFunc)nature_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(Diff2RB),"toggled",
		     (GtkSignalFunc)nature_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(ExprEd),"changed",
		     (GtkSignalFunc)expredch_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(ExprEd),"activate",
		     (GtkSignalFunc)funcok_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(FuncValB),"clicked",
		     (GtkSignalFunc)funcok_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(drEd),"changed",
		     (GtkSignalFunc)dredch_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(minpEd),"changed",
		     (GtkSignalFunc)minpedch_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(maxpEd),"changed",
		     (GtkSignalFunc)maxpedch_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(FList),"select_row",
		     (GtkSignalFunc)flistselect_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(FList),"unselect_row",
		     (GtkSignalFunc)flistunselect_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(FuncNewB),"clicked",
		     (GtkSignalFunc)funcnew_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(FuncDestroyB),"clicked",
		     (GtkSignalFunc)funcdestroy_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(FuncRenB),"clicked",
		     (GtkSignalFunc)funcren_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(SaveB),"clicked",
		     (GtkSignalFunc)save_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(SaveImageXPMB),"clicked",
		     (GtkSignalFunc)saveimagexpm_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(SaveImagePPMB),"clicked",
		     (GtkSignalFunc)saveimageppm_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(LoadB),"clicked",
		     (GtkSignalFunc)load_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(MergeB),"clicked",
		     (GtkSignalFunc)merge_event,(gpointer)this);
  gtk_signal_connect(GTK_OBJECT(RecalcB),"clicked",
		     (GtkSignalFunc)funcrecalc_event,(gpointer)this);
}

Fenetre::~Fenetre()
{
    LFonctions.Destroy();
    DeleteObject(axep);
    delete hdc;delete hdcMem;
}

void Fenetre::Retrace()
{
  ShowWait();
  gdk_gc_set_foreground(hdcMem->gc,&bgcolor);
  gdk_draw_rectangle(hbmMem,hdcMem->gc,TRUE,0,0,drawing_area->allocation.width,drawing_area->allocation.height);
  SelectObject(hdcMem,axep);
  Line(hdcMem,xlc-xech,yaxe,xlc+xech,yaxe);
  Line(hdcMem,xaxe,ylc-yech,xaxe,ylc+yech);
  long double x;
  if(yaxe>ylc-yech&&yaxe<ylc+yech){
    for(x=xlc;x<xlc+xech;x+=xgrad)Line(hdcMem,xphys(x),yphys(yaxe)-5,xphys(x),yphys(yaxe)+5);
    for(x=xlc;x>xlc-xech;x-=xgrad)Line(hdcMem,xphys(x),yphys(yaxe)-5,xphys(x),yphys(yaxe)+5);
  }
  if(xaxe>xlc-xech&&xaxe<xlc+xech){
    for(x=ylc;x<ylc+yech;x+=ygrad)Line(hdcMem,xphys(xaxe)-5,yphys(x),xphys(xaxe)+5,yphys(x));
    for(x=ylc;x>ylc-yech;x-=ygrad)Line(hdcMem,xphys(xaxe)-5,yphys(x),xphys(xaxe)+5,yphys(x));
  }
  for(int i=1;i<!LFonctions;i++)TraceFonction(hdcMem,&LFonctions[i]);
  HideWait();
}

void Fenetre::TraceCurs(HDC dc,double xc,double yc)
{
  if(xc!=ErrVal&&yc!=ErrVal){
    GdkFunction op=SelectFunction(dc,GDK_XOR);
    Line(dc,xphys(xc)-5,yphys(yc),xphys(xc)+5,yphys(yc));
    Line(dc,xphys(xc),yphys(yc)-5,xphys(xc),yphys(yc)+5);
    SelectFunction(dc,op);
  };
}

void Fenetre::Paint(GtkWidget*widget,GdkEventExpose *event)
{
  gdk_draw_pixmap(widget->window,
		  hdc->gc,
		  hbmMem,
		  event->area.x, event->area.y,
 		  event->area.x, event->area.y,
		  event->area.width, event->area.height);
  if(xcurs!=ErrVal&&ycurs!=ErrVal){
    SelectObject(hdc,axep);TraceCurs(hdc,xcurs,ycurs);//tester si le curseur est dans la zone
  }
}

int nbch(double l){return (int)floor(log10(fabs(l)));};

void Fenetre::MouseMove(int xp,int yp)
{
  if(Wait)return;
  double x0=xlog(xp),y0=ylog(yp),x1,y1,t1;
  SelectObject(hdc,axep);
  if(Suivre&&(!LFonctions)>1&&xcurs!=ErrVal)TraceCurs(hdc,xcurs,ycurs);
  int n1,n2,n3;double rmin=RMin(),rmax=RMax();
  n1=(!xlc||nbch(xlc)<=nbch(xech))?3:3+nbch(xlc)-nbch(xech);
  n2=(!ylc||nbch(ylc)<=nbch(yech))?3:3+nbch(ylc)-nbch(yech);
  n3=(!rmin||nbch(rmin)<=nbch(rmax-rmin))?3:3+nbch(rmin)-nbch(rmax-rmin);
  if(Suivre&&(!LFonctions)>1){
    xcurs=1E2000;double x,y,d;d=xcurs*xcurs;TPoint*ppoint;
    for(int i=1;i<!LFonctions;i++)for(int j=0;j<!LFonctions[i].LCourbes;j++)
      for(ppoint=LFonctions[i].LCourbes[j].prem;ppoint!=NULL;ppoint=ppoint->succ)
	if(((x=ppoint->x)-x0)*(x-x0)/(xech*xech)+((y=ppoint->y)-y0)*(y-y0)/(yech*yech)<d){
	  xcurs=x;ycurs=y;t1=ppoint->t;
	  PSelCourbeFonc=&LFonctions[i];SelCourbe=j;
	  d=(x-x0)*(x-x0)/(xech*xech)+(y-y0)*(y-y0)/(yech*yech);
	};
    if(xcurs!=1E2000){
      TraceCurs(hdc,xcurs,ycurs);x1=xcurs;y1=ycurs;
    }else{
      x1=x0;y1=y0;xcurs=ErrVal;t1=ErrVal;
    };
  }else{x1=x0;y1=y0;t1=ErrVal;};
  char s[50]="";sprintf(s,"x = %.*E",n1,x1);gtk_label_set_text(GTK_LABEL(XPos),s);
  sprintf(s,"y = %.*E",n2,y1);gtk_label_set_text(GTK_LABEL(YPos),s);
  r=sqrt(x1*x1+y1*y1);
  sprintf(s,"r = %.*E",n3,r);gtk_label_set_text(GTK_LABEL(RPos),s);
  if(x1||y1){a=atan2(y1,x1);sprintf(s,"a = %.*E",4,a);}
  else sprintf(s,"a undefined");gtk_label_set_text(GTK_LABEL(APos),s);
  if(PFoncSel!=&LFonctions[0]){
    x=x1;y=y1;double v=PFoncSel->pexpr->Val();
    if(v==ErrVal)sprintf(s,"undefined");else
      sprintf(s,"%.13E",v);
    gtk_label_set_text(GTK_LABEL(ValSt),s);
  };
  if(t1!=ErrVal){
    gtk_widget_set_sensitive(AbscSt1,TRUE);gtk_widget_set_sensitive(AbscSt2,TRUE);
    sprintf(s,"%.13E",t1);
    gtk_label_set_text(GTK_LABEL(AbscSt2),s);
  }else{
    gtk_widget_set_sensitive(AbscSt1,FALSE);gtk_widget_set_sensitive(AbscSt2,FALSE);
  };
}

void Fenetre::Redraw()
{
  Retrace();
  GdkRectangle rect;
  rect.x = 0;rect.y=0;
  rect.width=drawing_area->allocation.width;
  rect.height=drawing_area->allocation.height;
  gtk_widget_draw (drawing_area,&rect);
}

void Fenetre::Button1(int x,int y)
{
  if(Wait)return;
  if(PFoncSel==&LFonctions[0])return;
  ActivateWait();
  double x0=xlog(x),y0=ylog(y);
  if(Suivre&&xcurs!=ErrVal&&ycurs!=ErrVal){
    x0=xcurs;y0=ycurs;
    SelectObject(hdc,axep);TraceCurs(hdc,xcurs,ycurs);
  };
  char*Texte;
  if(GTK_TOGGLE_BUTTON(PointRB)->active){
    Texte=gtk_entry_get_text(GTK_ENTRY(XEd));
    double xp=atof(Texte);
    if(xp>xlc-xech&&xp<xlc+xech)x0=xp;
    Texte=gtk_entry_get_text(GTK_ENTRY(YEd));
    double yp=atof(Texte);
    if(yp>ylc-yech&&yp<ylc+yech)y0=yp;
  };
  if(!Contexte){
    if(PFoncSel->Diff==1){
      if(PFoncSel->t==0)TraceEqDiffYFX(hdc,x0,y0);else
	if(PFoncSel->t==1)TraceEqDiffXFY(hdc,x0,y0);else
	  if(PFoncSel->t==2)TraceEqDiffXYFXY(hdc,x0,y0);
    }else if(PFoncSel->Diff==2){
      if(PFoncSel->pexpr->ContainVar(*prvar)||PFoncSel->pexpr->ContainVar(*pavar))
	TraceNiv2(hdc,x0,y0);else TraceNiv(hdc,x0,y0);
    }else if(PFoncSel->Diff==3){
      if(PFoncSel->pexpr->ContainVar(*prvar)||PFoncSel->pexpr->ContainVar(*pavar))
	TraceChamp2(hdc,x0,y0);else TraceChamp(hdc,x0,y0);
    };
  }else if(Contexte==1){
    if(PFoncSel->Diff==1){
      if(PFoncSel->t==0)TraceFamEqDiffYFX(hdc,x0,y0);else
	if(PFoncSel->t==1)TraceFamEqDiffXFY(hdc,x0,y0);else
	  if(PFoncSel->t==2)TraceFamEqDiffXYFXY(hdc,x0,y0);
    }else
      if(PFoncSel->Diff==2){
	TraceFamNiv(hdc,x0,y0);
      }else
	if(PFoncSel->Diff==3){
	  TraceFamChamp(hdc,x0,y0);
	};
    Contexte=0;
  }else if(Contexte==2){
    ChercheNiv(hdc,x0,y0);
    Contexte=0;
  }else if(Contexte==3){
    char i=-1;
    if(PFoncSel->Diff==1&&PFoncSel->t==0)i=0;
    else if(PFoncSel->Diff==1&&PFoncSel->t==1)i=1;
    else if(PFoncSel->Diff==2)i=2;
    else if(PFoncSel->Diff==3)i=3;
    else if(PFoncSel->Diff==1&&PFoncSel->t==2)i=4;
    if(i!=-1)ChercheCroisement(hdc,x0,y0,i);
    Contexte=0;
  }else if(Contexte==4){
    char i=-1;
    if(PFoncSel->Diff==1&&PFoncSel->t==0)i=0;
    else if(PFoncSel->Diff==1&&PFoncSel->t==1)i=1;
    else if(PFoncSel->Diff==2)i=2;
    else if(PFoncSel->Diff==3)i=3;
    else if(PFoncSel->Diff==1&&PFoncSel->t==2)i=4;
    if(i!=-1)ChercheInflexion(hdc,x0,y0,i);
    Contexte=0;
  };
  DeactivateWait();
  if(Suivre&&xcurs!=ErrVal&&ycurs!=ErrVal){
    SelectObject(hdc,axep);TraceCurs(hdc,xcurs,ycurs);
  };
}

void Fenetre::Trace()
{
  Suivre^=1;
  if(Suivre){
    gtk_widget_set_sensitive(CrbDelB,TRUE);
  }else{
    gtk_widget_set_sensitive(CrbDelB,FALSE);
    PSelCourbeFonc=NULL;SelCourbe=-1;
    if(xcurs!=ErrVal){
      SelectObject(hdc,axep);
      TraceCurs(hdc,xcurs,ycurs);
    }
  }
  xcurs=ycurs=ErrVal;
}

void Fenetre::AxesDialog()
{
  char Texte[50]="";
  sprintf(Texte,"%g",xaxe);gtk_entry_set_text(GTK_ENTRY(xaxeEd),Texte);
  sprintf(Texte,"%g",yaxe);gtk_entry_set_text(GTK_ENTRY(yaxeEd),Texte);
  sprintf(Texte,"%g",xgrad);gtk_entry_set_text(GTK_ENTRY(xgradEd),Texte);
  sprintf(Texte,"%g",ygrad);gtk_entry_set_text(GTK_ENTRY(ygradEd),Texte);
  AxesColor_temp=axep->color;
  WColor_temp=bgcolor;
  gtk_grab_add(AxesDial);
  gtk_widget_show(AxesDial);
}

void Fenetre::AxesDialogOK()
{
  char* Texte;
  Texte=gtk_entry_get_text(GTK_ENTRY(xaxeEd));
  xaxe=atof(Texte);
  Texte=gtk_entry_get_text(GTK_ENTRY(yaxeEd));
  yaxe=atof(Texte);
  Texte=gtk_entry_get_text(GTK_ENTRY(xgradEd));
  xgrad=atof(Texte);
  Texte=gtk_entry_get_text(GTK_ENTRY(ygradEd));
  ygrad=atof(Texte);
  if(xech<=0||yech<=0){MessageBeep(-1);};
  axep->color=AxesColor_temp;
  bgcolor=WColor_temp;
  GdkColormap *colormap;
  colormap = gdk_window_get_colormap (drawing_area->window);
  gdk_color_alloc (colormap, &bgcolor);
  gdk_color_alloc(colormap,&axep->color);
  gtk_grab_remove(AxesDial);
  gtk_widget_hide(AxesDial);
  Redraw();
}

void Fenetre::AxesDialogCancel()
{
  gtk_grab_remove(AxesDial);
  gtk_widget_hide(AxesDial);
}

void Fenetre::AxesColorSelDialog()
{
  gdouble color[3];
  color[0]=AxesColor_temp.red/65536.;color[1]=AxesColor_temp.green/65536.;color[2]=AxesColor_temp.blue/65536.;
  gtk_color_selection_set_color(GTK_COLOR_SELECTION(GTK_COLOR_SELECTION_DIALOG(AxesColorSelDial)->colorsel),color);
  gtk_grab_add(AxesColorSelDial);
  gtk_widget_show(AxesColorSelDial);
}

void Fenetre::AxesColorSelDialogOK()
{
  gdouble color[3];
  gtk_color_selection_get_color(GTK_COLOR_SELECTION(GTK_COLOR_SELECTION_DIALOG(AxesColorSelDial)->colorsel),color);
  guint red,green,blue;
  red=(guint)(color[0]*65535.);
  green=(guint)(color[1]*65535.);
  blue=(guint)(color[2]*65535.);
  AxesColor_temp=RGB(red,green,blue);
  gtk_grab_remove(AxesColorSelDial);
  gtk_widget_hide(AxesColorSelDial);
}

void Fenetre::AxesColorSelDialogCancel()
{
  gtk_grab_remove(AxesColorSelDial);
  gtk_widget_hide(AxesColorSelDial);
}

void Fenetre::WColorSelDialog()
{
  gdouble color[3];
  color[0]=WColor_temp.red/65536.;color[1]=WColor_temp.green/65536.;color[2]=WColor_temp.blue/65536.;
  gtk_color_selection_set_color(GTK_COLOR_SELECTION(GTK_COLOR_SELECTION_DIALOG(WColorSelDial)->colorsel),color);
  gtk_grab_add(WColorSelDial);
  gtk_widget_show(WColorSelDial);
}

void Fenetre::WColorSelDialogOK()
{
  gdouble color[3];
  gtk_color_selection_get_color(GTK_COLOR_SELECTION(GTK_COLOR_SELECTION_DIALOG(WColorSelDial)->colorsel),color);
  guint red,green,blue;
  red=(guint)(color[0]*65535.);
  green=(guint)(color[1]*65535.);
  blue=(guint)(color[2]*65535.);
  WColor_temp=RGB(red,green,blue);
  gtk_grab_remove(WColorSelDial);
  gtk_widget_hide(WColorSelDial);
}

void Fenetre::WColorSelDialogCancel()
{
  gtk_grab_remove(WColorSelDial);
  gtk_widget_hide(WColorSelDial);
}

void Fenetre::ZoomDialog()
{
  char Texte[50]="";
  sprintf(Texte,"%g",xlc);gtk_entry_set_text(GTK_ENTRY(xlcEd),Texte);
  sprintf(Texte,"%g",ylc);gtk_entry_set_text(GTK_ENTRY(ylcEd),Texte);
  sprintf(Texte,"%g",xech);gtk_entry_set_text(GTK_ENTRY(xechEd),Texte);
  sprintf(Texte,"%g",yech);gtk_entry_set_text(GTK_ENTRY(yechEd),Texte);
  double xs=drawing_area->allocation.width,ys=drawing_area->allocation.height;
  sprintf(Texte,"%g",xyR*xs/ys);gtk_entry_set_text(GTK_ENTRY(xyEd),Texte);
  sprintf(Texte,"%g",ys/xs);gtk_entry_set_text(GTK_ENTRY(WAspEd),Texte);
  if(EchUnif==0)gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(xyWRB),TRUE);
  else if(EchUnif==1)gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(xWRB),TRUE);
  else if(EchUnif==2)gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(yWRB),TRUE);
  gtk_grab_add(ZoomDial);
  gtk_widget_show(ZoomDial);
}

void Fenetre::ZoomDialogOK()
{
  char* Texte;double xech2,yech2,WAsp,xyR2;
  Texte=gtk_entry_get_text(GTK_ENTRY(xechEd));
  xech2=atof(Texte);
  Texte=gtk_entry_get_text(GTK_ENTRY(yechEd));
  yech2=atof(Texte);
  Texte=gtk_entry_get_text(GTK_ENTRY(WAspEd));
  WAsp=atof(Texte);
  Texte=gtk_entry_get_text(GTK_ENTRY(xyEd));
  xyR2=atof(Texte);
  if(xech2==0||yech2==0||xyR2==0||WAsp==0){MessageBox("Zoom parameters","These numbers must be nonzero");return;}
  Texte=gtk_entry_get_text(GTK_ENTRY(xlcEd));
  xlc=atof(Texte);
  Texte=gtk_entry_get_text(GTK_ENTRY(ylcEd));
  ylc=atof(Texte);
  if(GTK_TOGGLE_BUTTON(xyWRB)->active)EchUnif=0;
  else if(GTK_TOGGLE_BUTTON(xWRB)->active)EchUnif=1;
  else if(GTK_TOGGLE_BUTTON(yWRB)->active)EchUnif=2;
  double xs=drawing_area->allocation.width,ys=drawing_area->allocation.height;
  xech=xech2;yech=yech2;xyR=xyR2*WAsp;
  if(ys<xs*WAsp){
    xs=ys/WAsp;
    gtk_widget_set_usize(drawing_area,(gint)xs,(gint)ys);
  }else if(ys>xs*WAsp){
    ys=xs*WAsp;
    gtk_widget_set_usize(drawing_area,(gint)xs,(gint)ys);
  }else Retaille((long int)xs,(long int)ys);
  gtk_grab_remove(ZoomDial);
  gtk_widget_hide(ZoomDial);
  for(int i=1;i<!LFonctions;i++)if(LFonctions[i].ZCalc)CalculeFonction(&LFonctions[i]);
  Redraw();
}

void Fenetre::ZoomDialogCancel()
{
  gtk_grab_remove(ZoomDial);
  gtk_widget_hide(ZoomDial);
}

void Fenetre::FoncSelLChanged()
{
  char *Texte=gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(FoncSelL)->entry));
  int j;
  for(j=0;j<!LFonctions;j++)if(!strcmp(Texte,LFonctions[j].nom)&&LFonctions[j].Diff){
    PFoncSel=&LFonctions[j];
    if(PFoncSel->Diff==1||PFoncSel->Diff==2||PFoncSel->Diff==3){
      gtk_widget_set_sensitive(PanoramaB,TRUE);
      gtk_widget_set_sensitive(LimCurvesB,TRUE);
      gtk_widget_set_sensitive(FamilyB,TRUE);
      gtk_widget_set_sensitive(CrossB,TRUE);
      gtk_widget_set_sensitive(InflexB,TRUE);
      gtk_widget_set_sensitive(FoncDelB,TRUE);
    }else{
      gtk_widget_set_sensitive(PanoramaB,FALSE);
      gtk_widget_set_sensitive(LimCurvesB,FALSE);
      gtk_widget_set_sensitive(FamilyB,FALSE);
      gtk_widget_set_sensitive(CrossB,FALSE);
      gtk_widget_set_sensitive(InflexB,FALSE);
      gtk_widget_set_sensitive(FoncDelB,FALSE);
    };
    if(PFoncSel->Diff==2)
      gtk_widget_set_sensitive(LevelB,FALSE);
    else gtk_widget_set_sensitive(LevelB,FALSE);
    break;
  };
  if(j==!LFonctions){
    PFoncSel=&LFonctions[0];
    gtk_widget_set_sensitive(PanoramaB,FALSE);
    gtk_widget_set_sensitive(LimCurvesB,FALSE);
    gtk_widget_set_sensitive(FamilyB,FALSE);
    gtk_widget_set_sensitive(LevelB,FALSE);
    gtk_widget_set_sensitive(CrossB,FALSE);
    gtk_widget_set_sensitive(InflexB,FALSE);
    gtk_widget_set_sensitive(FoncDelB,FALSE);
    return;
  }
  Contexte=0;
  gtk_label_set_text(GTK_LABEL(AideSt),"Click on the window to draw a curve of the selected function");
}

void Fenetre::Family()
{
  char Texte[40]="";sprintf(Texte,"%g",esp);char*Text2;
  if(InputDialog("Draw a family","Spacing (1=screen width):",Texte,&Text2)==InputDialog_OK){
    esp=atof(Text2);
    if(esp>PFoncSel->dr){
      Contexte=1;
      gtk_label_set_text(GTK_LABEL(AideSt),"Click on the window to draw a family of curves around a point");
    }else MessageBox("Draw a family","Spacing too small.");
  }
}

void Fenetre::Level()
{
  char Texte[40]="";sprintf(Texte,"%g",niv);char*Text2;
  if(InputDialog("Look for a level curve","Level value to get:",Texte,&Text2)==InputDialog_OK){
    niv=atof(Text2);
    Contexte=2;
    gtk_label_set_text(GTK_LABEL(AideSt),"Click on the window to draw the nearest curve with the requested level value");
  }
}

void Fenetre::Cross()
{
  Contexte=3;
  gtk_label_set_text(GTK_LABEL(AideSt),"Click on the window to draw the nearest crossing");
}

void Fenetre::Inflex()
{
  Contexte=4;
  gtk_label_set_text(GTK_LABEL(AideSt),"Click on the window to draw the nearest inflection points");
}

void Fenetre::LimCurves()
{
  if(PFoncSel==&LFonctions[0])return;
  ActivateWait();
  char i=-1;
  if(PFoncSel->Diff==1&&PFoncSel->t==0)i=0;
  else if(PFoncSel->Diff==1&&PFoncSel->t==1)i=1;
  else if(PFoncSel->Diff==2)i=2;
  else if(PFoncSel->Diff==3)i=3;
  else if(PFoncSel->Diff==1&&PFoncSel->t==2)i=4;
  if(i!=-1)ChercheElts(hdc,i);
  DeactivateWait();
}

void Fenetre::Panorama()
{
  if(PFoncSel==&LFonctions[0])return;
  char Texte[40]="";sprintf(Texte,"%g",esp);char*Text2;
  if(InputDialog("Panorama","Spacing (1=screen width):",Texte,&Text2)==InputDialog_OK){
    esp=atof(Text2);
    if(esp<PFoncSel->dr){MessageBox("Panorama","Spacing too small.");return;}
    ActivateWait();
    char i=-1;
    if(PFoncSel->Diff==1&&PFoncSel->t==0)i=64;
    else if(PFoncSel->Diff==1&&PFoncSel->t==1)i=65;
    else if(PFoncSel->Diff==2)i=66;
    else if(PFoncSel->Diff==3)i=67;
    else if(PFoncSel->Diff==1&&PFoncSel->t==2)i=68;
    if(i!=-1)ChercheElts(hdc,i);
    DeactivateWait();
  }
}

void Fenetre::CrbDel()
{
  if(SelCourbe==-1||PSelCourbeFonc==NULL)return;
  PSelCourbeFonc->LCourbes.DestroyObject(SelCourbe);
  PSelCourbeFonc->Calc=0;xcurs=ErrVal;
  Redraw();SelCourbe=-1;
}

void Fenetre::FoncDel()
{
  if(PFoncSel==&LFonctions[0])return;
  PFoncSel->LCourbes.Destroy();
  Redraw();
}

int Fenetre::StringInFoncSelL(char*s)
{
  char*t;int n=g_list_length(FoncSelList);
  for(int i=0;i<n;i++){
    t=(char*)g_list_nth_data(FoncSelList,i);
    if(!strcmp(s,t))return i;
  };
  return 0;
}

int Fenetre::StringInFList(char*s)
{
  char*t;
  for(int i=0;i<!LFonctions;i++){
    gtk_clist_get_text(GTK_CLIST(FList),i,0,&t);
    if(!strcmp(s,t))return i;
  };
  return 0;
}

void Fenetre::ActivateWait()
{
  Wait=1;Interrupt=0;
  gtk_label_set_text(GTK_LABEL(AideSt),"Right mouse button click to stop a curve\n Right mouse button double click to stop process");
}

void Fenetre::DeactivateWait()
{
  Wait=0;Interrupt=0;
  gtk_label_set_text(GTK_LABEL(AideSt),"Click on the window to draw a curve of the selected function");
}

void Fenetre::ShowWait()
{
  gtk_label_set_text(GTK_LABEL(AideSt),"Please wait");
}
void Fenetre::HideWait()
{
  gtk_label_set_text(GTK_LABEL(AideSt),"Click on the window to draw a curve of the selected function");
}

char Fenetre::InterruptionToRepeat()
{
  while (gtk_events_pending())gtk_main_iteration();
  return (Interrupt?Interrupt--:0);
}

char Fenetre::InterruptionNotToRepeat()
{
  while (gtk_events_pending())gtk_main_iteration();
  return (Interrupt?Interrupt--:0);
}

void Fenetre::MessageBeep(int)
{printf("Not possible.\n");
}
