/*

Copyright Yann OLLIVIER 1997-1999

This software may be freely distributed as is, including
this whole notice.

It may be modified, but any modification should include this whole notice as 
is and a description of the changes made.

This software may not be sold.

This software or any modified version of it may be freely used in free
programs. The program should include a copy of this whole notice. If you
want to use it in a program you sell, contact me

This software comes with absolutely no warranty.

*/

class Fenetre;

class Pen{
 public:
  GdkLineStyle style;
  gint width;
  GdkColor color;
};
typedef Pen* HPEN;

class DC{
 public:
  GdkDrawable** drawable;
  Fenetre* fenetre;
  GdkGC* gc;
  DC(Fenetre*);
  ~DC();
  gint xcurr,ycurr;
};
typedef DC* HDC;

//typedef GdkPixmap*HBITMAP;
//typedef int MSG;
HPEN CreatePen(GdkLineStyle style,gint width,GdkColor color);
const GdkLineStyle PS_SOLID=GDK_LINE_SOLID;
void DeleteObject(HPEN);
void SelectObject(HDC,HPEN);
GdkColor RGB(int red,int green,int blue);
GdkFunction SelectFunction(HDC,GdkFunction);

int operator==(GdkColor,GdkColor);
int operator!=(GdkColor,GdkColor);

void Line(HDC,double,double);
void Go(HDC,double,double);
void Line(HDC,double,double,double,double);
void Line(HDC,long int,long int);
void Go(HDC,long int,long int);
void Line(HDC,long int,long int,long int,long int);

const int InputDialog_OK=1,InputDialog_Cancel=0;

class InputDialogClass{
  GtkWidget *window,*label,*entry;
  char**dest;int Ind;
  InputDialogClass();
  friend void InputDialOK(GtkWidget*,gpointer);
  friend void InputDialCancel(GtkWidget*,gpointer);
 public:
  friend int InputDialog(char*title,char*prompt,char*init,char**dest);
};

const int AskDialog_Yes=1,AskDialog_No=0;

class AskDialogClass{
  GtkWidget *window,*label;
  int Ind;
  AskDialogClass();
  friend void AskDialYes(GtkWidget*,gpointer);
  friend void AskDialNo(GtkWidget*,gpointer);
 public:
  friend int AskDialog(char*title,char*ask);
};

class MessageBoxClass{
  GtkWidget *window,*label;
  int Ind;
  MessageBoxClass();
  friend void MessageBoxDialYes(GtkWidget*,gpointer);
 public:
  friend void MessageBox(char*title,char*ask);
};

const int FileSelDialog_OK=1,FileSelDialog_Cancel=0;

class FileSelDialogClass{
  GtkWidget*window;
  int Ind;
  FileSelDialogClass();
  friend void FileSelDialOK(GtkWidget*,FileSelDialogClass*);
  friend void FileSelDialCancel(GtkWidget*,FileSelDialogClass*);
 public:
  friend char* FileSelDialog();
};

void InputDialOK(GtkWidget*,gpointer pointer);
void InputDialCancel(GtkWidget*,gpointer pointer);
int AskDialog(char*title,char*prompt);
void AskDialYes(GtkWidget*,gpointer pointer);
void AskDialNo(GtkWidget*,gpointer pointer);
void MessageBoxDialYes(GtkWidget*,gpointer pointer);
void FileSelDialOK(GtkWidget*,FileSelDialogClass*FileSelDial);
void FileSelDialCancel(GtkWidget*,FileSelDialogClass*FileSelDial);
void MessageBox(char*title,char*prompt);
int InputDialog(char*title,char*prompt,char*init,char**destp);
char* FileSelDialog();
