/*

Copyright Yann OLLIVIER 1997-1999

This software may be freely distributed as is, including
this whole notice.

It may be modified, but any modification should include this whole notice as 
is and a description of the changes made.

This software may not be sold.

This software or any modified version of it may be freely used in free
programs. The program should include a copy of this whole notice. If you
want to use it in a program you sell, contact me

This software comes with absolutely no warranty.

*/

#include"eqdiff.h"

void Fenetre::TraceFamEqDiffYFX(HDC dc,double x0,double y0)
{
  double dx,z,z2,sgn,dx2,dist,x1,y1;int k;
  xmin=xlc-xech*1.2;xmax=xlc+xech*1.2;
  ymin=ylc-yech*1.2;ymax=ylc+yech*1.2;
  FBornes=1;
  TCourbe*pcrb=new TCourbe;
  TraceEqDiffYFX(dc,x0,y0);
  for(short i=0;i<2;i++){
    sgn=(i?1:-1);x=x0;y=y0;dist=0;if(!i)pcrb->AjouteFin(x,y);
    z2=PFoncSel->pexpr->Val();
    if(z2==ErrVal){
      x+=PFoncSel->dr*xech*sgn;dist+=PFoncSel->dr;z2=PFoncSel->pexpr->Val();
      if(z2==ErrVal||z2==0){MessageBeep(-1);break;};
    };
    if(z2==0){
      y-=PFoncSel->dr*yech*sgn;dist+=PFoncSel->dr;z2=PFoncSel->pexpr->Val();
      if(z2==ErrVal||z2==0){MessageBeep(-1);break;};
    };
    dx2=PFoncSel->dr/hypot(1/xech,yech/(z2*xech*xech));
    do{
      z=PFoncSel->pexpr->Val();if(z==0){
	y-=PFoncSel->dr*yech*sgn;dist+=PFoncSel->dr;z=PFoncSel->pexpr->Val();
	if(z==ErrVal||z2==0)break;
	z2=0;
      }else if(z!=ErrVal){
	dx=PFoncSel->dr/hypot(1/xech,yech/(z*xech*xech));
	if(z2==ErrVal||z2==0){z2=z;dx2=dx;}else
	  if(fabsl(1/z-1/z2)*dx/(2*dx2)>xech/yech){
	    if(z*z2<0)sgn*=-1;
	    z2=z;dx2=dx;}
	x+=dx*sgn;y-=dx*sgn*(1/z+(1/z-1/z2)*dx/(2*dx2))*yech*yech/(xech*xech);
	dist+=PFoncSel->dr;
	z2=z;dx2=dx;}else{
	  if(z2==ErrVal||z2==0)break;
	  x+=dx2*sgn;y-=dx2*sgn/z2*yech*yech/(xech*xech);
	  z2=ErrVal;dx2=dx;dist+=PFoncSel->dr;};
      if(!IndLimCourbes){
	for(k=0;k<!LCourbesLim&&
	      !TestePoint(&(LCourbesLim[k]),x,y,PFoncSel->dr/2);k++);
	if(k<!LCourbesLim)break;
      };
      if(dist>esp){
	dist-=esp;x1=x;y1=y;
	TraceEqDiffYFX(dc,x,y);
	x=x1;y=y1;};
      if(TestePoint(pcrb,x,y,PFoncSel->dr/2))
	{if(i)pcrb->AjouteFin(x,y);else pcrb->AjouteDeb(x,y);
	break;};
      for(k=0;k<!LCourbesLim&&
	    !TestePoint(&(LCourbesLim[k]),x,y,PFoncSel->dr/2);k++);
      if(k<!LCourbesLim)break;
      if(i)pcrb->AjouteFin(x,y);else pcrb->AjouteDeb(x,y);
      if(PFoncSel->IntS){
	if(InterruptionNotToRepeat())break;
      };
    }while(x<xmax&&x>xmin&&y<ymax&&y>ymin);
  };
  if(IndLimCourbes)LCourbesLim.AddObject(pcrb);else pcrb->Detruit();
  FBornes=0;
}

void Fenetre::TraceFamEqDiffXFY(HDC dc,double x0,double y0)
{
  double dy,z,z2,sgn,dy2,dist,x1,y1;int k;
  xmin=xlc-xech*1.2;xmax=xlc+xech*1.2;
  ymin=ylc-yech*1.2;ymax=ylc+yech*1.2;
  FBornes=1;
  TCourbe*pcrb=new TCourbe;
  TraceEqDiffXFY(dc,x0,y0);
  for(short i=0;i<2;i++){
    sgn=(i?1:-1);x=x0;y=y0;dist=0;if(!i)pcrb->AjouteFin(x,y);
    z2=PFoncSel->pexpr->Val();
    if(z2==ErrVal){
      y+=PFoncSel->dr*yech*sgn;dist+=PFoncSel->dr;z2=PFoncSel->pexpr->Val();
      if(z2==ErrVal||z2==0){MessageBeep(-1);break;};
    };
    if(z2==0){
      x-=PFoncSel->dr*xech*sgn;dist+=PFoncSel->dr;z2=PFoncSel->pexpr->Val();
      if(z2==ErrVal||z2==0){MessageBeep(-1);break;};
    };
    dy2=PFoncSel->dr/hypot(1/yech,xech/(z2*yech*yech));
    do{
      z=PFoncSel->pexpr->Val();if(z==0){
	x-=PFoncSel->dr*xech*sgn;dist+=PFoncSel->dr;z=PFoncSel->pexpr->Val();
	if(z==ErrVal||z2==0)break;
	z2=0;
      }else if(z!=ErrVal){
	dy=PFoncSel->dr/hypot(1/yech,xech/(z*yech*yech));
	if(z2==ErrVal||z2==0){z2=z;dy2=dy;}else
	  if(fabsl(1/z-1/z2)*dy/(2*dy2)>yech/xech){
	    if(z*z2<0)sgn=-sgn;
	    z2=z;dy2=dy;};
	y+=dy*sgn;x-=dy*sgn*(1/z+(1/z-1/z2)*dy/(2*dy2))*xech*xech/(yech*yech);
	dist+=PFoncSel->dr;
	z2=z;dy2=dy;}else{
	  if(z2==ErrVal||z2==0)break;
	  y+=dy2*sgn;x-=dy2*sgn/z2*xech*xech/(yech*yech);
	  z2=ErrVal;dy2=dy;dist+=PFoncSel->dr;};
      if(!IndLimCourbes){
	for(k=0;k<!LCourbesLim&&
	      !TestePoint(&(LCourbesLim[k]),x,y,PFoncSel->dr/2);k++);
	if(k<!LCourbesLim)break;
      };
      if(dist>esp){
	dist-=esp;x1=x;y1=y;
	TraceEqDiffXFY(dc,x,y);
	x=x1;y=y1;};
      if(TestePoint(pcrb,x,y,PFoncSel->dr/2))
	{if(i)pcrb->AjouteFin(x,y);else pcrb->AjouteDeb(x,y);
	break;};
      for(k=0;k<!LCourbesLim&&
	    !TestePoint(&(LCourbesLim[k]),x,y,PFoncSel->dr/2);k++);
      if(k<!LCourbesLim)break;
      if(i)pcrb->AjouteFin(x,y);else pcrb->AjouteDeb(x,y);
      if(PFoncSel->IntS){
	if(InterruptionNotToRepeat())break;
      };
    }while(x<xmax&&x>xmin&&y<ymax&&y>ymin);
  };
  if(IndLimCourbes)LCourbesLim.AddObject(pcrb);else pcrb->Detruit();
  FBornes=0;
}

void Fenetre::TraceFamNiv(HDC dc,double x0,double y0)
{
  double dx,dy,dzdx,dzdy,dzdx2,dzdy2,sgn,dr,n,dx2,dy2,x1,y1,dist;int k;
  xmin=xlc-xech*1.2;xmax=xlc+xech*1.2;
  ymin=ylc-yech*1.2;ymax=ylc+yech*1.2;
  FBornes=1;
  TCourbe*pcrb=new TCourbe;
  TraceNiv2(dc,x0,y0);
  dr=PFoncSel->dr;                                
  for(short i=0;i<2;i++){
    sgn=(i?1:-1);x=x0;y=y0;dist=0;r=hypot(x,y);if(x||y)a=atan2(y,x);else a=0;
    if(!i)pcrb->AjouteFin(x,y);
    dzdx2=PFoncSel->pexprder->Val();dzdy2=PFoncSel->pexprder2->Val();
    if(dzdx2==ErrVal||dzdy2==ErrVal){MessageBeep(-1);break;};
    n=hypot(dzdx2*xech,dzdy2*yech);if(!n){MessageBeep(-1);break;};
    dx2=dzdx2/n*xech;dy2=dzdy2/n*yech;
    do{
      r=hypot(x,y);if(x||y)a=atan2(y,x);
      dzdx=PFoncSel->pexprder->Val();dzdy=PFoncSel->pexprder2->Val();
      if(dzdx==ErrVal||dzdy==ErrVal)break;
      if(fabsl(dzdx-dzdx2)*xech>4)dzdx2=dzdx;
      if(fabsl(dzdy-dzdy2)*yech>4)dzdy2=dzdy;
      dx=(dzdx+(dzdx-dzdx2)/2)*xech;dy=(dzdy+(dzdy-dzdy2)/2)*yech;
      if(!(dx||dy)||dx*dx2+dy*dy2<0)break;
      n=sgn*dr/hypot(dx,dy);
      x+=dx*n*xech;y+=dy*n*yech;dist+=dr;
      dzdx2=dzdx;dzdy2=dzdy;dx2=dx;dy2=dy;
      if(TestePoint(pcrb,x,y,dr/2)){
	if(i)pcrb->AjouteFin(x,y);else pcrb->AjouteDeb(x,y);
	break;};
      if(!IndLimCourbes){
	for(k=0;k<!LCourbesLim&&
	      !TestePoint(&(LCourbesLim[k]),x,y,PFoncSel->dr/2);k++);
	if(k<!LCourbesLim)break;
      };
      if(dist>esp){
	dist-=esp;x1=x;y1=y;
	TraceNiv2(dc,x,y);
	x=x1;y=y1;};          
      if(i)pcrb->AjouteFin(x,y);else pcrb->AjouteDeb(x,y);
      if(PFoncSel->IntS){
	if(InterruptionNotToRepeat())break;
      };
    }while(x<xmax&&x>xmin&&y<ymax&&y>ymin);
  };
  if(IndLimCourbes)LCourbesLim.AddObject(pcrb);else pcrb->Detruit();
  FBornes=0;
}

void Fenetre::TraceFamChamp(HDC dc,double x0,double y0)
{
  double dzdx,dzdy,dx,dy,z,n,z0,sgn,dr,x1,y1,dist;
  int k;
  xmin=xlc-xech*1.2;xmax=xlc+xech*1.2;
  ymin=ylc-yech*1.2;ymax=ylc+yech*1.2;
  FBornes=1;
  TraceChamp2(dc,x0,y0);
  TCourbe*pcrb=new TCourbe;
  dr=PFoncSel->dr;
  x=x0;y=y0;r=hypot(x,y);if(x||y)a=atan2(y,x);else a=0;
  z0=PFoncSel->pexpr->Val();
  if(z0==ErrVal){MessageBeep(-1);FBornes=0;return;};
  dzdx=PFoncSel->pexprder->Val();dzdy=PFoncSel->pexprder2->Val();
  if((dzdx==ErrVal||dzdy==ErrVal)||(!(dzdx||dzdy))){FBornes=0;return;};
  pcrb->AjouteFin(x0,y0);
  for(short i=0;i<2;i++){
    sgn=(i?1:-1);x=x0;y=y0;dx=0;dy=0;dist=0;
    do{
      r=hypot(x,y);if(x||y)a=atan2(y,x);
      dzdx=PFoncSel->pexprder->Val();dzdy=PFoncSel->pexprder2->Val();
      z=PFoncSel->pexpr->Val();
      if(z==ErrVal||dzdx==ErrVal||dzdy==ErrVal)break;
      n=hypot(dzdx*xech,dzdy*yech);
      if(dzdx*dx*xech+dzdy*dy*yech<-n/2)sgn=-sgn;
      if(dzdx||dzdy){
	dx=dzdx/n*xech;dy=dzdy/n*yech;
	if(fabsl(z-z0)>n*dr/2)break;
	x+=(-sgn*dr*dy-(z-z0)*dx/n)*xech;
	y+=(sgn*dr*dx-(z-z0)*dy/n)*yech;
	dist+=dr;
      }else if((dx||dy)&&PFoncSel->opt==1){
	x+=-sgn*dr*dy*xech;
	y+=sgn*dr*dx*yech;
	dx=0;dy=0;dist+=dr;
      }else break;
      if(!IndLimCourbes){
	for(k=0;k<!LCourbesLim&&
	      !TestePoint(&(LCourbesLim[k]),x,y,PFoncSel->dr/2);k++);
	if(k<!LCourbesLim)break;
      };
      if(dist>esp){
	dist-=esp;x1=x;y1=y;
	TraceChamp2(dc,x,y);
	x=x1;y=y1;};
      if(TestePoint(pcrb,x,y,dr/2)){
	if(i)pcrb->AjouteFin(x,y);else pcrb->AjouteDeb(x,y);
	break;};
      for(k=0;k<!LCourbesLim&&
	    !TestePoint(&(LCourbesLim[k]),x,y,PFoncSel->dr/2);k++);
      if(k<!LCourbesLim)break;
      if(i)pcrb->AjouteFin(x,y);else pcrb->AjouteDeb(x,y);
      if(PFoncSel->IntS){
	if(InterruptionNotToRepeat())break;
      };
    }while(x<xmax&&x>xmin&&y<ymax&&y>ymin);
  };
  if(IndLimCourbes)LCourbesLim.AddObject(pcrb);else pcrb->Detruit();
  FBornes=0;
}

void Fenetre::ChercheNiv(HDC dc,double&x0,double&y0,char action)
{double dx=0,dy=0,dzdx,dzdy,dzdx2,dzdy2,sgn,dr,n=0,z,r1,r2,z2;
char Ind=0;
if(!FBornes){xmax=xlc+xech;xmin=xlc-xech;ymax=ylc+yech;ymin=ylc-yech;};
TCourbe*pcrb=new TCourbe;
dr=PFoncSel->dr;
pcrb->AjouteFin(x0,y0);                  
for(short i=0;!Ind&&i<2;i++){            
x=x0;y=y0;r=hypot(x,y);if(x||y)a=atan2(y,x);else a=0;
z=PFoncSel->pexpr->Val();z2=z;
dzdx2=PFoncSel->pexprder->Val();dzdy2=PFoncSel->pexprder2->Val();
if(z==ErrVal||dzdx2==ErrVal||dzdy2==ErrVal||!(dzdx2||dzdy2)){
	r1=alea()*1024,r2=alea()*1024;
	x+=dr*(r1-512.)/512.;y+=dr*(r2-512.)/512.;
	r=hypot(x,y);if(x||y)a=atan2(y,x);
	z=PFoncSel->pexpr->Val();z2=z;
	dzdx2=PFoncSel->pexprder->Val();dzdy2=PFoncSel->pexprder2->Val();
	};
if(z==niv){
	if(action){if(PFoncSel->pexpr->ContainVar(*pavar)||PFoncSel->pexpr->ContainVar(*prvar))
		TraceNiv2(dc,x,y,niv);else TraceNiv(dc,x,y,niv);}else{
    x0=x;y0=y;};
  return;
  };
sgn=(z<niv?1:-1)*(i?-1:1);
if(z!=ErrVal&&dzdx2!=ErrVal&&dzdy2!=ErrVal&&(dzdx2||dzdy2))
do{
	r=hypot(x,y);if(x||y)a=atan2(y,x);
	z=PFoncSel->pexpr->Val();
	dzdx=PFoncSel->pexprder->Val();dzdy=PFoncSel->pexprder2->Val();
	if(z==ErrVal||dzdx==ErrVal||dzdy==ErrVal){
		if(dzdx2==ErrVal||dzdy2==ErrVal){
			r1=alea()*1024;r2=alea()*1024;
			x+=dr*(r1-512.)/512.;y+=dr*(r2-512.)/512.;
			r=hypot(x,y);if(x||y)a=atan2(y,x);
			z=PFoncSel->pexpr->Val();z2=z;
			dzdx2=PFoncSel->pexprder->Val();dzdy2=PFoncSel->pexprder2->Val();
			if(z==ErrVal||dzdx2==ErrVal||dzdy2==ErrVal)break;
      dzdx2=0;dzdy2=0;
			}else{
			x+=dx*n*xech;y+=dy*n*yech;dzdx2=ErrVal;dzdy2=ErrVal;z2=z;
      };
  	}else{
	if((z-niv)*(z-niv)<dr*dr*(dzdx*dzdx*xech*xech+dzdy*dzdy*yech*yech)
		||(z-niv)*(z2-niv)<=0){
		x-=n*dx*xech;y-=n*dy*yech;
		Ind=ChercheNivAutour(dc,x,y,action);
		if(Ind)break;
		x+=n*dx*xech;y+=n*dy*yech;
		};
	if(dzdx2==ErrVal||fabsl(dzdx-dzdx2)*xech>4)dzdx2=dzdx;
	if(dzdy2==ErrVal||fabsl(dzdy-dzdy2)*yech>4)dzdy2=dzdy;
	dx=(dzdx+(dzdx-dzdx2)/2)*xech;dy=(dzdy+(dzdy-dzdy2)/2)*yech;
	if(!(dx||dy)){
		dx=dzdx*xech;dy=dzdy*yech;
		if(!(dx||dy)){
			r1=alea()*1024;r2=alea()*1024;dx=r1-512.;dy=r2-512.;
    	};
		}
	if(dx*dzdx2+dy*dzdy2<0)sgn*=-1;
	n=sgn*dr/hypot(dx,dy);
	x+=dx*n*xech;y+=dy*n*yech;
	if(dx*dzdx2+dy*dzdy2<0){
		x-=n*dx*xech;y-=n*dy*yech;
		Ind=ChercheNivAutour(dc,x,y,action);
		if(Ind)break;
		x+=n*dx*xech;y+=n*dy*yech;
		};
	dzdx2=dzdx;dzdy2=dzdy;z2=z;};
	if(TestePoint(pcrb,x,y,dr/4)){
		if(i)pcrb->AjouteDeb(x,y);else pcrb->AjouteFin(x,y);
		break;
		};                                                 
	if(i)pcrb->AjouteDeb(x,y);else pcrb->AjouteFin(x,y);
	if(PFoncSel->IntS){
	  if(InterruptionNotToRepeat())break;
		};
}while(x<xmax&&x>xmin&&y<ymax&&y>ymin);
};
pcrb->Detruit();
if(!Ind&&action)MessageBox("Look for a level curve","Value not found");
if(!action){if(Ind){x0=x;y0=y;}else{x0=ErrVal;y0=ErrVal;};};
}

char Fenetre::ChercheNivAutour(HDC dc,double&x0,double&y0,char action)
{double x1=x,y1=y,z,dzdx,dzdy,n,dr=PFoncSel->dr;
x=x0;y=y0;a=0;
do{
	r=hypot(x,y);if(x||y)a=atan2(y,x);
	z=PFoncSel->pexpr->Val();
	dzdx=PFoncSel->pexprder->Val();dzdy=PFoncSel->pexprder2->Val();
  if(z==ErrVal||dzdx==ErrVal||dzdy==ErrVal)break;
	n=dzdx*dzdx*xech*xech+dzdy*dzdy*yech*yech;
	if(n){x+=(niv-z)*dzdx/(2*n)*xech*xech;y+=(niv-z)*dzdy/(2*n)*yech*yech;};
	}while(fabsl(niv-z)<sqrt(n)*dr*4&&fabsl(niv-z)>sqrt(n)*dr*dr);
if(fabsl(niv-z)>sqrt(n)*dr*4){x=x1;y=y1;return 0;};
if(action){if(PFoncSel->pexpr->ContainVar(*pavar)||PFoncSel->pexpr->ContainVar(*prvar))
	TraceNiv2(dc,x,y,niv);else TraceNiv(dc,x,y,niv);}else{
  x0=x;y0=y;};
return 1;
}

void Fenetre::TraceEqDiffXYFXY(HDC dc,double x0,double y0)
{double dx,dy,xder,yder,xder2,yder2,sgn,dr,n,dx2,dy2,dr2,a1,a2,absc,dd;
PROperation pexprx=new ROperation(PFoncSel->pexpr->NthMember(1)),
	pexpry=new ROperation(PFoncSel->pexpr->NthMember(2));
if(!FBornes){xmax=xlc+xech;xmin=xlc-xech;ymax=ylc+yech;ymin=ylc-yech;};
TCourbe*pcrb=new TCourbe;PFoncSel->LCourbes.AddObject(pcrb);
SelectObject(dc,PFoncSel->hp);
dr=PFoncSel->dr;
pcrb->AjouteFin(x0,y0,0);
short i=0;if(dxsens||dysens)i=1;
for(;i<2;i++){
sgn=(i?1:-1);x=x0;y=y0;absc=0;dd=0;
Go(dc,x0,y0);
xder2=pexprx->Val();yder2=pexpry->Val();
if(xder2==ErrVal||yder2==ErrVal||!(xder2||yder2)){MessageBeep(-1);break;};
n=hypot(xder2/xech,yder2/yech);
dx2=sgn*dr*xder2/n;dy2=dr*yder2/n*sgn;
if(sgn*dx2*dxsens/(xech*xech)+sgn*dy2*dysens/(yech*yech)<0)
	{sgn=-sgn;dx2=-dx2;dy2=-dy2;};
a2=atan2(dy2,dx2);dr2=.5;
do{
	xder=pexprx->Val();yder=pexpry->Val();
	if(xder==ErrVal||yder==ErrVal){
		if(!PFoncSel->opt||xder2==ErrVal||yder2==ErrVal)break;
		x+=dx;y+=dy;xder2=ErrVal;yder2=ErrVal;dx2=dx;dy2=dy;a2=ErrVal;
		absc+=hypot(dx,dy);
  	}else{
		if(xder2==ErrVal||yder2==ErrVal){xder2=xder;yder2=yder;dx2=dx;dy2=dy;};
		if(xder*xder2/(xech*xech)+yder*yder2/(yech*yech)<0)
			{if(PFoncSel->opt)sgn*=-1;else break;};
		if(!(xder||yder)){if(PFoncSel->opt){xder=xder2;yder=yder2;if(!(xder||yder))break;}else break;}
		n=sgn*dr/hypot(xder/xech,yder/yech);
		dx=xder*n;dy=yder*n;a1=atan2(dy,dx);
		if(a2!=ErrVal)dr2=1/(fabsl(a1-a2)/(dr*dr2*6.28)+1);
			else dr2=1;if(dr2<dr)dr2=dr;
		x+=(dx+(dx-dx2)/2)*dr2;y+=(dy+(dy-dy2)/2)*dr2;
    absc+=dr2*hypot(dx,dy);
		xder2=xder;yder2=yder;dx2=dx;dy2=dy;a2=a1;
		};
	if(PFoncSel->TestPts&&TestePoint(pcrb,x,y,dr*dr2/2))
		{if(i)pcrb->AjouteFin(x,y,absc);else pcrb->AjouteDeb(x,y,-absc);
		Line(dc,x,y);break;};
	if(i)pcrb->AjouteFin(x,y,absc);else pcrb->AjouteDeb(x,y,-absc);
	if(!IndLimCourbes)Line(dc,x,y);else{
		dd-=PFoncSel->dr;if(dd<=0){
			dd=TestePointLim(x,y,PFoncSel->dr*1.5);if(!dd)break;
      };
		};
	if(!PFoncSel->TestPts&&PFoncSel->TestPtI&&
		((x-x0)*(x-x0)/(xech*xech)+(y-y0)*(y-y0)/(yech*yech))<=dr*dr/4){i=2;break;};
	if(PFoncSel->IntS){
	  if(InterruptionNotToRepeat())break;
		};
}while(x<xmax&&x>xmin&&y<ymax&&y>ymin);
if(IndLimCourbes&&dd<=0)break;
};
if(!IndLimCourbes||dd>0)TraceCourbe(hdcMem,pcrb,PFoncSel->hp);
if(IndLimCourbes&&dd>0)TraceCourbe(dc,pcrb,PFoncSel->hp);
if(IndLimCourbes&&dd<=0)
	PFoncSel->LCourbes.DestroyObject(!PFoncSel->LCourbes-1);
}

void Fenetre::TraceFamEqDiffXYFXY(HDC dc,double x0,double y0)
{double dx,dy,xder,yder,xder2,yder2,sgn,dr,n,dx2,dy2,x1,y1,dist;int k;
PROperation pexprx=new ROperation(PFoncSel->pexpr->NthMember(1)),
	pexpry=new ROperation(PFoncSel->pexpr->NthMember(2));
xmin=xlc-xech*1.2;xmax=xlc+xech*1.2;
ymin=ylc-yech*1.2;ymax=ylc+yech*1.2;
FBornes=1;
TCourbe*pcrb=new TCourbe;
dr=PFoncSel->dr;
pcrb->AjouteFin(x0,y0);
TraceEqDiffXYFXY(dc,x0,y0);
for(short i=0;i<2;i++){
sgn=(i?1:-1);x=x0;y=y0;dist=0;
xder2=pexpry->Val();yder2=pexprx->Val();
if(xder2==ErrVal||yder2==ErrVal){MessageBeep(-1);break;};
xder2*=-xech/yech;yder2*=yech/xech;
n=hypot(xder2/xech,yder2/yech);if(!n){MessageBeep(-1);break;};
dx2=sgn*dr*xder2/n;dy2=sgn*dr*yder2/n;
do{
	xder=pexpry->Val();yder=pexprx->Val();
	if(xder==ErrVal||yder==ErrVal){
		if(!PFoncSel->opt||xder2==ErrVal||yder2==ErrVal)break;
		x+=dx;y+=dy;xder2=ErrVal;yder2=ErrVal;dx2=dx;dy2=dy;dist+=dr;
		}else{
	xder*=-xech/yech;yder*=yech/xech;
	if(xder2==ErrVal||yder2==ErrVal){xder2=xder;yder2=yder;dx2=dx;dy2=dy;};
	if(xder*xder2/(xech*xech)+yder*yder2/(yech*yech)<0)
		{if(PFoncSel->opt)sgn*=-1;else break;};
	if(!(xder||yder)){if(PFoncSel->opt){xder=xder2;yder=yder2;if(!(xder||yder))break;}else break;}
	n=sgn*dr/hypot(xder/xech,yder/yech);
  dx=xder*n;dy=yder*n;
	x+=dx+(dx-dx2)/2;y+=dy+(dy-dy2)/2;
	xder2=xder;yder2=yder;dx2=dx;dy2=dy;dist+=dr;};
	if(!IndLimCourbes){
		for(k=0;k<!LCourbesLim&&
			!TestePoint(&(LCourbesLim[k]),x,y,PFoncSel->dr/2);k++);
		if(k<!LCourbesLim)break;
		};
	if(dist>esp){
		dist-=esp;x1=x;y1=y;
		TraceEqDiffXYFXY(dc,x,y);
		x=x1;y=y1;};
	if(TestePoint(pcrb,x,y,dr/2))
		{if(i)pcrb->AjouteFin(x,y);else pcrb->AjouteDeb(x,y);break;};
	for(k=0;k<!LCourbesLim&&
		!TestePoint(&(LCourbesLim[k]),x,y,PFoncSel->dr/2);k++);
  if(k<!LCourbesLim)break;
	if(i)pcrb->AjouteFin(x,y);else pcrb->AjouteDeb(x,y);
	if(PFoncSel->IntS){
	  if(InterruptionNotToRepeat())break;
		};
}while(x<xmax&&x>xmin&&y<ymax&&y>ymin);
};
if(IndLimCourbes)LCourbesLim.AddObject(pcrb);else pcrb->Detruit();
FBornes=0;
}

void Fenetre::ChercheElts(HDC dc,char i)
{
  PROperation pexprx,pexpry;TCourbe*pcrb=new TCourbe,*pcrb2=new TCourbe;
  PFoncSel->dr/=2;FBornes=1;
  xmin=xlc-xech*2;xmax=xlc+xech*2;
  ymin=ylc-yech*2;ymax=ylc+yech*2;
  char Ind=0,Ind2=0;IndLimCourbes=0;;if(i>=64){i-=64;Ind=1;};
  switch(i){
  case 0:pexprx=new ROperation(1.);pexpry=PFoncSel->pexpr;break;//eqdiff yfx
  case 1:pexpry=new ROperation(1.);pexprx=PFoncSel->pexpr;break;//eqdiff xfy
  case 2:pexprx=new ROperation(-*PFoncSel->pexprder2);//niv
    pexpry=PFoncSel->pexprder;break;
  case 3:pexprx=PFoncSel->pexprder;pexpry=PFoncSel->pexprder2;break;//champ
  case 4:pexprx=new ROperation(PFoncSel->pexpr->NthMember(1));
    pexpry=new ROperation(PFoncSel->pexpr->NthMember(2));break;//eqdiff xyfxy
  };
  double k,dx,dy,s1=0,s2=0,sgn=1,dx2=0,dy2=0,dr=PFoncSel->dr,ksup=7;a=0;
  for(k=0;k<2*3.141592653589793+PFoncSel->dr;k+=dr){
    x=xlc+1.8*xech*cos(k);y=ylc+1.8*yech*sin(k);
    r=hypot(x,y);if(x||y)a=atan2(y,x);
    dx=pexprx->Val();dy=pexpry->Val();
    if(dx!=ErrVal&&dy!=ErrVal){
      if(dx2*dx/(xech*xech)+dy2*dy/(yech*yech)>=0||dr!=PFoncSel->dr){
	if(sgn*((x-xlc)*dx/xech+(y-ylc)*dy/yech)<0){
	  sgn=-sgn;Ind2=1;};
	s1=sgn*(-dx*(y-ylc)*xech/yech+dy*(x-xlc)*yech/xech);
	dxsens=xlc-x;dysens=ylc-y;if(dx2*dx/(xech*xech)+dy2*dy/(yech*yech)<0){dxsens=0;dysens=0;};
	if(Ind2){
	  if(s1*s2<=0&&s2/*s1<=0&&s2>=0*/)pcrb2->AjouteFin(xlc+0.9*xech*cos(k),ylc+0.9*yech*sin(k));
	  s2=0;Ind2=0;};
	if(s1>=0&&s2<0){
	  switch(i){
	  case 0:TraceEqDiffYFX(dc,x,y);break;
	  case 1:TraceEqDiffXFY(dc,x,y);break;
	  case 2:TraceNiv2(dc,x,y);break;
	  case 3:TraceChamp2(dc,x,y);break;
	  case 4:TraceEqDiffXYFXY(dc,x,y);break;
	  };
	  pcrb->AjouteFin(xlc+0.9*xech*cos(k),ylc+0.9*yech*sin(k));
	  LCourbesLim.CopyObject(PFoncSel->LCourbes[!PFoncSel->LCourbes-1]);
	};
	s2=s1;dx2=dx;dy2=dy;
      }else{
	ksup=k;k-=dr;dr*=dr;s2=0;dx2=0;dy2=0;
      };
    }else{s2=0;dx2=0;dy2=0;};
    if(k>ksup){ksup=7;dr=PFoncSel->dr;};
    if(InterruptionNotToRepeat())break;
  };
  switch(i){
  case 0:case 2:delete pexprx;break;
  case 1:delete pexpry;break;
  default:break;
  };
  FBornes=0;
  PFoncSel->dr*=2;
  dxsens=0;dysens=0;
  TCourbe*pcrbtmp;int c=0;
  if(Ind){
    TPoint*ppoint=pcrb->prem;if(ppoint==NULL){ppoint=pcrb2->prem;IndLimCourbes=1;};
    for(;ppoint!=NULL;ppoint=ppoint->succ,c++){
      if(!IndLimCourbes){pcrbtmp=&LCourbesLim[c];LCourbesLim.DelObject(c);};
      switch(i){
      case 0:TraceFamEqDiffYFX(dc,ppoint->x,ppoint->y);break;
      case 1:TraceFamEqDiffXFY(dc,ppoint->x,ppoint->y);break;
      case 2:TraceFamNiv(dc,ppoint->x,ppoint->y);break;
      case 3:TraceFamChamp(dc,ppoint->x,ppoint->y);break;
      case 4:TraceFamEqDiffXYFXY(dc,ppoint->x,ppoint->y);break;
      };
      if(!IndLimCourbes)LCourbesLim.AddObject(pcrbtmp,c);
    };
  };
  pcrb->Detruit();pcrb2->Detruit();LCourbesLim.Destroy();IndLimCourbes=0;
}

void Fenetre::AnalyseEqDiffYFX(double&z0,double&sgn,double&dxr)
{double y0,y1,z1,ds0,ds1,z,b1,b2;
y0=y;
if((b1=PFoncSel->pexprder->Val())==ErrVal||(b2=PFoncSel->pexprder2->Val())==ErrVal)
	{sgn=0;return;};
ds0=b1+z0*b2;
y+=PFoncSel->dr*yech*sgn*(z0>0?1:-1);y1=y;
z1=PFoncSel->pexpr->Val();
if(z1==ErrVal||(b1=PFoncSel->pexprder->Val())==ErrVal||(b2=PFoncSel->pexprder2->Val())==ErrVal)
	{sgn=0;return;};
ds1=b1+z1*b2;
if(ds1*z1*sgn>0)if(ds0*z0*sgn>0&&PFoncSel->opt){sgn=-sgn;y=y0;return;}
	else {sgn=0;return;};
y=(y0+y1)/2;
for(short i=0;i<10;i++){
	z=PFoncSel->pexpr->Val();if(z==ErrVal){sgn=0;return;};
	if(z*z1>0)y1=y;else y0=y;
	y=(y0+y1)/2;
	};
z0=PFoncSel->pexpr->Val();if(z0==ErrVal){sgn=0;return;};
if((b1=PFoncSel->pexprder->Val())==ErrVal||(b2=PFoncSel->pexprder2->Val())==ErrVal)
	{sgn=0;return;};
ds0=b1+z0*b2;
dxr=PFoncSel->dr/hypot(1/xech,z0/yech)/3;
z0+=ds0*dxr/2*sgn;
}

void Fenetre::AnalyseEqDiffXFY(double&z0,double&sgn,double&dyr)
{double x0,x1,z1,ds0,z,b1,b2,ds1;
x0=x;
if((b1=PFoncSel->pexprder->Val())==ErrVal||(b2=PFoncSel->pexprder2->Val())==ErrVal)
	{sgn=0;return;};
ds0=b1*z0+b2;
x+=PFoncSel->dr*xech*sgn*(z0>0?1:-1);x1=x;
z1=PFoncSel->pexpr->Val();
if(z1==ErrVal||(b1=PFoncSel->pexprder->Val())==ErrVal||(b2=PFoncSel->pexprder2->Val())==ErrVal)
	{sgn=0;return;};
ds1=b1*z1+b2;
if(ds1*z1*sgn>0)if(ds0*z0*sgn>0&&PFoncSel->opt){sgn=-sgn;x=x0;return;}
	else {sgn=0;return;};
x=(x0+x1)/2;
for(short i=0;i<10;i++){
	z=PFoncSel->pexpr->Val();if(z==ErrVal){sgn=0;return;};
	if(z*z1>0)x1=x;else x0=x;
	x=(x0+x1)/2;
	};
z0=PFoncSel->pexpr->Val();if(z0==ErrVal){sgn=0;return;};
if((b1=PFoncSel->pexprder->Val())==ErrVal||(b2=PFoncSel->pexprder2->Val())==ErrVal)
	{sgn=0;return;};
ds0=b1*z0+b2;
dyr=PFoncSel->dr/hypot(1/yech,z0/xech)/3;
z0+=ds0*dyr/2*sgn;
}

PROperation Fenetre::DeriveX(PROperation pop)
{ROperation drdx=(ROperation)(*pxvar)/(ROperation)(*prvar),dadx=-(ROperation)(*pyvar)/((*prvar)*(ROperation)(*prvar));
ROperation*pder=new ROperation;
*pder=pop->Diff(*pxvar)+pop->Diff(*prvar)*drdx+
	pop->Diff(*pavar)*dadx;
return pder;
}

PROperation Fenetre::DeriveY(PROperation pop)
{ROperation drdy=(ROperation)(*pyvar)/(ROperation)(*prvar),dady=(*pxvar)/((*prvar)*(ROperation)(*prvar));
ROperation*pder=new ROperation;
*pder=pop->Diff(*pyvar)+pop->Diff(*prvar)*drdy+pop->Diff(*pavar)*dady;
return pder;
}
//beaucoup de place mmoire ?
void Fenetre::ChercheCroisement(HDC dc,double x0,double y0,char i)
{PROperation pexprx,pexpry,pexprxy,pexpryx,pexprxx,pexpryy;
char Ind=0;
switch(i){
	case 0:pexprx=new ROperation(1.);pexpry=PFoncSel->pexpr;break;//eqdiff yfx
	case 1:pexpry=new ROperation(1.);pexprx=PFoncSel->pexpr;break;//eqdiff xfy
	case 2:pexprx=new ROperation(-*PFoncSel->pexprder2);//niv
		pexpry=PFoncSel->pexprder;break;
	case 3:pexprx=PFoncSel->pexprder;pexpry=PFoncSel->pexprder2;break;//champ
	case 4:pexprx=new ROperation(PFoncSel->pexpr->NthMember(1));
		pexpry=new ROperation(PFoncSel->pexpr->NthMember(2));break;//eqdiff xyfxy
	};
TFonction*pf=new TFonction("",
		new ROperation(((*pexprx)^2)/(xech*xech)+((*pexpry)^2)/(yech*yech)),
		PFoncSel->dr,PFoncSel->hp,2,0,0,ErrVal,ErrVal);
pf->Calc=1;
pf->pexprder=DeriveX(pf->pexpr);pf->pexprder2=DeriveY(pf->pexpr);
pexprxx=DeriveX(pexprx);pexprxy=DeriveY(pexprx);
pexpryx=DeriveX(pexpry);pexpryy=DeriveY(pexpry);
TFonction*pfs=PFoncSel;PFoncSel=pf;double niv2=niv,x1=x0,y1=y0;
niv=0;ChercheNiv(dc,x1,y1,0);
niv=niv2;PFoncSel=pfs;delete pf;
double e,b,c,d,derx,dery,det,a1,a2;
if(x1==ErrVal||y1==ErrVal)goto fin;
x=x1;y=y1;r=hypot(x,y);if(x||y)a=atan2(y,x);else a=0;
derx=pexprx->Val();dery=pexpry->Val();
e=pexprxx->Val();b=pexprxy->Val();c=pexpryx->Val();d=pexpryy->Val();
if(derx==ErrVal||dery==ErrVal||e==ErrVal||b==ErrVal||c==ErrVal||d==ErrVal)goto fin;
det=(e+d)*(e+d)-4*(e*d-b*c);if(det<=0)goto fin;else det=sqrt(det);
if(b){
	Ind=1;          
	a1=atan2((d-e+det)/2*xech,b*yech);a2=atan2((d-e-det)/2*xech,b*yech);
	}else if(c){
	Ind=1;
	a1=atan2(c*xech,(d-e+det)/2*yech);a2=atan2(c*xech,(d-e-det)/2*yech);
	}else if(e*d){
	Ind=1;
  a1=0;a2=3.1415926535897932384L/2.;
  }else goto fin;
TraceCroisement(dc,x1,y1,a1,i);
TraceCroisement(dc,x1,y1,a1+3.1415926535897932384L,i);
TraceCroisement(dc,x1,y1,a2,i);
TraceCroisement(dc,x1,y1,a2+3.1415926535897932384L,i);
fin:
if(!Ind)MessageBox("Crossing","No crossing found around this point");
switch(i){
	case 0:case 2:delete pexprx;break;
	case 1:delete pexpry;break;
	default:break;
	};
delete pexprxx;delete pexprxy;delete pexpryx;delete pexpryy;
}

void Fenetre::TraceCroisement(HDC dc,double x0,double y0,double a,char i)
{dxsens=PFoncSel->dr*cos(a)*xech,dysens=PFoncSel->dr*sin(a)*yech;
double x1=x0+dxsens,y1=y0+dysens;
switch(i){
	case 0:TraceEqDiffYFX(dc,x1,y1);break;
	case 1:TraceEqDiffXFY(dc,x1,y1);break;
	case 2:TraceNiv2(dc,x1,y1);break;
	case 3:TraceChamp2(dc,x1,y1);break;
	case 4:TraceEqDiffXYFXY(dc,x1,y1);break;
	};
TPoint*ppoint=PFoncSel->LCourbes[!PFoncSel->LCourbes-1].prem;
if(ppoint!=NULL){if(ppoint->x==x1&&ppoint->y==y1)
	PFoncSel->LCourbes[!PFoncSel->LCourbes-1].AjouteDeb(x0,y0);else
	PFoncSel->LCourbes[!PFoncSel->LCourbes-1].AjouteFin(x0,y0);
	};
SelectObject(dc,PFoncSel->hp);
Go(dc,x0,y0);Line(dc,x1,y1);
dxsens=dysens=0;
}

void Fenetre::ChercheInflexion(HDC dc,double x0,double y0,char i)
{
  PROperation pexprx,pexpry;
  char Ind=0;
  switch(i){
  case 0:pexprx=new ROperation(1.);pexpry=PFoncSel->pexpr;break;//eqdiff yfx
  case 1:pexpry=new ROperation(1.);pexprx=PFoncSel->pexpr;break;//eqdiff xfy
  case 2:pexprx=new ROperation(-*PFoncSel->pexprder2);//niv
    pexpry=PFoncSel->pexprder;break;
  case 3:pexprx=PFoncSel->pexprder;pexpry=PFoncSel->pexprder2;break;//champ
  case 4:pexprx=new ROperation(PFoncSel->pexpr->NthMember(1));
    pexpry=new ROperation(PFoncSel->pexpr->NthMember(2));break;//eqdiff xyfxy
  };
  PROperation pop=new ROperation(
				 ((*pexprx)^2)*(*DeriveX(pexpry))-((*pexpry)^2)*(*DeriveY(pexprx))+
				 (*pexprx)*(*pexpry)*(*DeriveY(pexpry)-*DeriveX(pexprx)));
  TFonction*pf=new TFonction("",pop,PFoncSel->dr,PFoncSel->hp,2,0,0,ErrVal,ErrVal);
  pf->Calc=1;
  pf->pexprder=DeriveX(pf->pexpr);pf->pexprder2=DeriveY(pf->pexpr);
  TFonction*pfs=PFoncSel;PFoncSel=pf;double niv2=niv,x1=x0,y1=y0;
  niv=0;ChercheNiv(dc,x1,y1,0);if(x1==ErrVal||y1==ErrVal)goto fin;
  Ind=1;
  x=x1;y=y1;
  TraceNiv2(dc,x1,y1);niv=niv2;
  pfs->LCourbes.CopyObject(PFoncSel->LCourbes[0]);
  PFoncSel=pfs;delete pf;
 fin:
  if(!Ind)MessageBox("Inflection points","No inflection points were found around this point");
  switch(i){
  case 0:case 2:delete pexprx;break;
  case 1:delete pexpry;break;
  default:break;
  };
}
